package b4a.example3;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (processBA == null) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "b4a.example3", "b4a.example3.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example3", "b4a.example3.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example3.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        if (mostCurrent != null)
            processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

private static BA killProgramHelper(BA ba) {
    if (ba == null)
        return null;
    anywheresoftware.b4a.BA.SharedProcessBA sharedProcessBA = ba.sharedProcessBA;
    if (sharedProcessBA == null || sharedProcessBA.activityBA == null)
        return null;
    return sharedProcessBA.activityBA.get();
}
public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = killProgramHelper(main.mostCurrent == null ? null : main.mostCurrent.processBA);
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

BA.applicationContext.stopService(new android.content.Intent(BA.applicationContext, starter.class));
}
public anywheresoftware.b4a.keywords.Common __c = null;
public b4a.example3.customlistview _clv1 = null;
public anywheresoftware.b4a.objects.B4XViewWrapper _lbltitle = null;
public anywheresoftware.b4a.objects.B4XViewWrapper _pnltitle = null;
public static int _expandedheight = 0;
public static int _collapsedheight = 0;
public anywheresoftware.b4a.objects.B4XViewWrapper _pnlexpanded = null;
public anywheresoftware.b4a.objects.B4XViewWrapper.XUI _xui = null;
public anywheresoftware.b4a.objects.collections.List _listheight = null;
public anywheresoftware.b4a.objects.ListViewWrapper _listview1 = null;
public b4a.example3.starter _starter = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_create"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_create", new Object[] {_firsttime});
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131073;
 //BA.debugLineNum = 131073;BA.debugLine="Activity.LoadLayout(\"1\")";
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
RDebugUtils.currentLine=131074;
 //BA.debugLineNum = 131074;BA.debugLine="listHeight.Initialize";
mostCurrent._listheight.Initialize();
RDebugUtils.currentLine=131075;
 //BA.debugLineNum = 131075;BA.debugLine="listCv";
_listcv();
RDebugUtils.currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="End Sub";
return "";
}
public static String  _listcv() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "listcv"))
	return (String) Debug.delegate(mostCurrent.activityBA, "listcv", null);
anywheresoftware.b4a.objects.collections.Map _map = null;
RDebugUtils.currentLine=786432;
 //BA.debugLineNum = 786432;BA.debugLine="Public Sub listCv";
RDebugUtils.currentLine=786433;
 //BA.debugLineNum = 786433;BA.debugLine="For Each map As Map In categories";
_map = new anywheresoftware.b4a.objects.collections.Map();
{
final anywheresoftware.b4a.BA.IterableList group1 = _categories();
final int groupLen1 = group1.getSize()
;int index1 = 0;
;
for (; index1 < groupLen1;index1++){
_map.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(group1.Get(index1)));
RDebugUtils.currentLine=786434;
 //BA.debugLineNum = 786434;BA.debugLine="clv1.Add(CreateItem(Rnd(0xFF000000, 0xFFFFFFFF),";
mostCurrent._clv1._add(null,_createitem(anywheresoftware.b4a.keywords.Common.Rnd((int) (0xff000000),(int) (0xffffffff)),BA.ObjectToString(_map.Get((Object)("title"))),(int)(BA.ObjectToNumber(_map.Get((Object)("size"))))),(Object)(_map.getObject()));
 }
};
RDebugUtils.currentLine=786436;
 //BA.debugLineNum = 786436;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=720896;
 //BA.debugLineNum = 720896;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=720898;
 //BA.debugLineNum = 720898;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_resume"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_resume", null);
RDebugUtils.currentLine=655360;
 //BA.debugLineNum = 655360;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=655362;
 //BA.debugLineNum = 655362;BA.debugLine="End Sub";
return "";
}
public static String  _animatedarrow(int _index,int _from,int _todegree) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "animatedarrow"))
	return (String) Debug.delegate(mostCurrent.activityBA, "animatedarrow", new Object[] {_index,_from,_todegree});
anywheresoftware.b4a.objects.B4XViewWrapper _iv = null;
RDebugUtils.currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Sub AnimatedArrow(index As Int, From As Int, ToDeg";
RDebugUtils.currentLine=458753;
 //BA.debugLineNum = 458753;BA.debugLine="pnlTitle = clv1.GetPanel(index).GetView(0) 'pnlTi";
mostCurrent._pnltitle = mostCurrent._clv1._getpanel(null,_index).GetView((int) (0));
RDebugUtils.currentLine=458754;
 //BA.debugLineNum = 458754;BA.debugLine="Dim iv As B4XView = pnlTitle.GetView(1) 'ImageVie";
_iv = new anywheresoftware.b4a.objects.B4XViewWrapper();
_iv = mostCurrent._pnltitle.GetView((int) (1));
RDebugUtils.currentLine=458755;
 //BA.debugLineNum = 458755;BA.debugLine="iv.SetRotationAnimated(0, From)";
_iv.SetRotationAnimated((int) (0),(float) (_from));
RDebugUtils.currentLine=458756;
 //BA.debugLineNum = 458756;BA.debugLine="iv.SetRotationAnimated(clv1.AnimationDuration, To";
_iv.SetRotationAnimated(mostCurrent._clv1._animationduration,(float) (_todegree));
RDebugUtils.currentLine=458757;
 //BA.debugLineNum = 458757;BA.debugLine="End Sub";
return "";
}
public static anywheresoftware.b4a.objects.collections.List  _categories() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "categories"))
	return (anywheresoftware.b4a.objects.collections.List) Debug.delegate(mostCurrent.activityBA, "categories", null);
anywheresoftware.b4a.objects.collections.List _list = null;
anywheresoftware.b4a.objects.collections.Map _map1 = null;
anywheresoftware.b4a.objects.collections.Map _map2 = null;
anywheresoftware.b4a.objects.collections.Map _map3 = null;
anywheresoftware.b4a.objects.collections.Map _map4 = null;
RDebugUtils.currentLine=851968;
 //BA.debugLineNum = 851968;BA.debugLine="Public Sub categories As List";
RDebugUtils.currentLine=851969;
 //BA.debugLineNum = 851969;BA.debugLine="Dim list As List";
_list = new anywheresoftware.b4a.objects.collections.List();
RDebugUtils.currentLine=851970;
 //BA.debugLineNum = 851970;BA.debugLine="list.Initialize";
_list.Initialize();
RDebugUtils.currentLine=851971;
 //BA.debugLineNum = 851971;BA.debugLine="Dim map1 As Map = CreateMap(\"title\":\"Gloria\",\"siz";
_map1 = new anywheresoftware.b4a.objects.collections.Map();
_map1 = anywheresoftware.b4a.keywords.Common.createMap(new Object[] {(Object)("title"),(Object)("Gloria"),(Object)("size"),(Object)(1)});
RDebugUtils.currentLine=851972;
 //BA.debugLineNum = 851972;BA.debugLine="list.Add(map1)";
_list.Add((Object)(_map1.getObject()));
RDebugUtils.currentLine=851973;
 //BA.debugLineNum = 851973;BA.debugLine="Dim map2 As Map = CreateMap(\"title\":\"Winter\",\"siz";
_map2 = new anywheresoftware.b4a.objects.collections.Map();
_map2 = anywheresoftware.b4a.keywords.Common.createMap(new Object[] {(Object)("title"),(Object)("Winter"),(Object)("size"),(Object)(12)});
RDebugUtils.currentLine=851974;
 //BA.debugLineNum = 851974;BA.debugLine="list.Add(map2)";
_list.Add((Object)(_map2.getObject()));
RDebugUtils.currentLine=851975;
 //BA.debugLineNum = 851975;BA.debugLine="Dim map3 As Map = CreateMap(\"title\":\"Nestle\",\"siz";
_map3 = new anywheresoftware.b4a.objects.collections.Map();
_map3 = anywheresoftware.b4a.keywords.Common.createMap(new Object[] {(Object)("title"),(Object)("Nestle"),(Object)("size"),(Object)(2)});
RDebugUtils.currentLine=851976;
 //BA.debugLineNum = 851976;BA.debugLine="list.Add(map3)";
_list.Add((Object)(_map3.getObject()));
RDebugUtils.currentLine=851977;
 //BA.debugLineNum = 851977;BA.debugLine="Dim map4 As Map = CreateMap(\"title\":\"Coca-cola\",\"";
_map4 = new anywheresoftware.b4a.objects.collections.Map();
_map4 = anywheresoftware.b4a.keywords.Common.createMap(new Object[] {(Object)("title"),(Object)("Coca-cola"),(Object)("size"),(Object)(22)});
RDebugUtils.currentLine=851978;
 //BA.debugLineNum = 851978;BA.debugLine="list.Add(map4)";
_list.Add((Object)(_map4.getObject()));
RDebugUtils.currentLine=851979;
 //BA.debugLineNum = 851979;BA.debugLine="Return list";
if (true) return _list;
RDebugUtils.currentLine=851980;
 //BA.debugLineNum = 851980;BA.debugLine="End Sub";
return null;
}
public static String  _clv1_itemclick(int _index,Object _value) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "clv1_itemclick"))
	return (String) Debug.delegate(mostCurrent.activityBA, "clv1_itemclick", new Object[] {_index,_value});
anywheresoftware.b4a.objects.B4XViewWrapper _p = null;
RDebugUtils.currentLine=589824;
 //BA.debugLineNum = 589824;BA.debugLine="Sub clv1_ItemClick (Index As Int, Value As Object)";
RDebugUtils.currentLine=589825;
 //BA.debugLineNum = 589825;BA.debugLine="Dim p As B4XView = clv1.GetPanel(Index)";
_p = new anywheresoftware.b4a.objects.B4XViewWrapper();
_p = mostCurrent._clv1._getpanel(null,_index);
RDebugUtils.currentLine=589826;
 //BA.debugLineNum = 589826;BA.debugLine="If p.Tag = True Then";
if ((_p.getTag()).equals((Object)(anywheresoftware.b4a.keywords.Common.True))) { 
RDebugUtils.currentLine=589827;
 //BA.debugLineNum = 589827;BA.debugLine="CollapseItem(Index)";
_collapseitem(_index);
 }else {
RDebugUtils.currentLine=589829;
 //BA.debugLineNum = 589829;BA.debugLine="ExpandItem(Index)";
_expanditem(_index);
 };
RDebugUtils.currentLine=589831;
 //BA.debugLineNum = 589831;BA.debugLine="End Sub";
return "";
}
public static String  _collapseitem(int _index) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "collapseitem"))
	return (String) Debug.delegate(mostCurrent.activityBA, "collapseitem", new Object[] {_index});
RDebugUtils.currentLine=524288;
 //BA.debugLineNum = 524288;BA.debugLine="Sub CollapseItem(index As Int)";
RDebugUtils.currentLine=524289;
 //BA.debugLineNum = 524289;BA.debugLine="clv1.ResizeItem(index, CollapsedHeight)";
mostCurrent._clv1._resizeitem(null,_index,_collapsedheight);
RDebugUtils.currentLine=524290;
 //BA.debugLineNum = 524290;BA.debugLine="clv1.GetPanel(index).Tag = False";
mostCurrent._clv1._getpanel(null,_index).setTag((Object)(anywheresoftware.b4a.keywords.Common.False));
RDebugUtils.currentLine=524291;
 //BA.debugLineNum = 524291;BA.debugLine="AnimatedArrow(index, 180, 0)";
_animatedarrow(_index,(int) (180),(int) (0));
RDebugUtils.currentLine=524292;
 //BA.debugLineNum = 524292;BA.debugLine="End Sub";
return "";
}
public static String  _expanditem(int _index) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "expanditem"))
	return (String) Debug.delegate(mostCurrent.activityBA, "expanditem", new Object[] {_index});
RDebugUtils.currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Sub ExpandItem (index As Int)";
RDebugUtils.currentLine=393217;
 //BA.debugLineNum = 393217;BA.debugLine="clv1.ResizeItem(index, listHeight.Get(index))";
mostCurrent._clv1._resizeitem(null,_index,(int)(BA.ObjectToNumber(mostCurrent._listheight.Get(_index))));
RDebugUtils.currentLine=393218;
 //BA.debugLineNum = 393218;BA.debugLine="clv1.GetPanel(index).Tag = True";
mostCurrent._clv1._getpanel(null,_index).setTag((Object)(anywheresoftware.b4a.keywords.Common.True));
RDebugUtils.currentLine=393219;
 //BA.debugLineNum = 393219;BA.debugLine="AnimatedArrow(index, 0, 180)";
_animatedarrow(_index,(int) (0),(int) (180));
RDebugUtils.currentLine=393220;
 //BA.debugLineNum = 393220;BA.debugLine="End Sub";
return "";
}
public static anywheresoftware.b4a.objects.B4XViewWrapper  _createitem(int _clr,String _title,int _size) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "createitem"))
	return (anywheresoftware.b4a.objects.B4XViewWrapper) Debug.delegate(mostCurrent.activityBA, "createitem", new Object[] {_clr,_title,_size});
anywheresoftware.b4a.objects.B4XViewWrapper _p = null;
int _i = 0;
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub CreateItem(clr As Int, title As String, size A";
RDebugUtils.currentLine=196609;
 //BA.debugLineNum = 196609;BA.debugLine="Dim p As B4XView = xui.CreatePanel(\"\")";
_p = new anywheresoftware.b4a.objects.B4XViewWrapper();
_p = mostCurrent._xui.CreatePanel(processBA,"");
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="p.SetLayoutAnimated(0, 0, 0, clv1.AsView.Width, E";
_p.SetLayoutAnimated((int) (0),(int) (0),(int) (0),mostCurrent._clv1._asview(null).getWidth(),_expandedheight);
RDebugUtils.currentLine=196611;
 //BA.debugLineNum = 196611;BA.debugLine="p.LoadLayout(\"Item\")";
_p.LoadLayout("Item",mostCurrent.activityBA);
RDebugUtils.currentLine=196613;
 //BA.debugLineNum = 196613;BA.debugLine="ListView1.SingleLineLayout.Label.Height = 50dip";
mostCurrent._listview1.getSingleLineLayout().Label.setHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (50)));
RDebugUtils.currentLine=196614;
 //BA.debugLineNum = 196614;BA.debugLine="ExpandedHeight = (ListView1.SingleLineLayout.Labe";
_expandedheight = (int) ((mostCurrent._listview1.getSingleLineLayout().Label.getHeight()*(_size+1))+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (20)));
RDebugUtils.currentLine=196615;
 //BA.debugLineNum = 196615;BA.debugLine="listHeight.Add(ExpandedHeight)";
mostCurrent._listheight.Add((Object)(_expandedheight));
RDebugUtils.currentLine=196616;
 //BA.debugLineNum = 196616;BA.debugLine="ListView1.SingleLineLayout.Label.TextColor = Colo";
mostCurrent._listview1.getSingleLineLayout().Label.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
RDebugUtils.currentLine=196617;
 //BA.debugLineNum = 196617;BA.debugLine="p.SetLayoutAnimated(0, 0, 0, p.Width, CollapsedHe";
_p.SetLayoutAnimated((int) (0),(int) (0),(int) (0),_p.getWidth(),_collapsedheight);
RDebugUtils.currentLine=196619;
 //BA.debugLineNum = 196619;BA.debugLine="pnlExpanded.Height = ExpandedHeight";
mostCurrent._pnlexpanded.setHeight(_expandedheight);
RDebugUtils.currentLine=196620;
 //BA.debugLineNum = 196620;BA.debugLine="ListView1.Height = ExpandedHeight";
mostCurrent._listview1.setHeight(_expandedheight);
RDebugUtils.currentLine=196621;
 //BA.debugLineNum = 196621;BA.debugLine="lblTitle.Text = title";
mostCurrent._lbltitle.setText(BA.ObjectToCharSequence(_title));
RDebugUtils.currentLine=196622;
 //BA.debugLineNum = 196622;BA.debugLine="pnlTitle.Color = clr";
mostCurrent._pnltitle.setColor(_clr);
RDebugUtils.currentLine=196623;
 //BA.debugLineNum = 196623;BA.debugLine="pnlExpanded.Color = ShadeColor(clr)";
mostCurrent._pnlexpanded.setColor(_shadecolor(_clr));
RDebugUtils.currentLine=196625;
 //BA.debugLineNum = 196625;BA.debugLine="For i=0 To size - 1";
{
final int step14 = 1;
final int limit14 = (int) (_size-1);
_i = (int) (0) ;
for (;(step14 > 0 && _i <= limit14) || (step14 < 0 && _i >= limit14) ;_i = ((int)(0 + _i + step14))  ) {
RDebugUtils.currentLine=196626;
 //BA.debugLineNum = 196626;BA.debugLine="ListView1.AddSingleLine2($\"Item ${title}-->${i+1";
mostCurrent._listview1.AddSingleLine2(BA.ObjectToCharSequence(("Item "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_title))+"-->"+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_i+1))+"")),(Object)(("id: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_title))+"-"+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_i+1))+"")));
 }
};
RDebugUtils.currentLine=196628;
 //BA.debugLineNum = 196628;BA.debugLine="p.Tag = False 'collapsed";
_p.setTag((Object)(anywheresoftware.b4a.keywords.Common.False));
RDebugUtils.currentLine=196629;
 //BA.debugLineNum = 196629;BA.debugLine="Return p";
if (true) return _p;
RDebugUtils.currentLine=196630;
 //BA.debugLineNum = 196630;BA.debugLine="End Sub";
return null;
}
public static int  _shadecolor(int _clr) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "shadecolor"))
	return (Integer) Debug.delegate(mostCurrent.activityBA, "shadecolor", new Object[] {_clr});
int[] _argb = null;
float _factor = 0f;
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub ShadeColor(clr As Int) As Int";
RDebugUtils.currentLine=262145;
 //BA.debugLineNum = 262145;BA.debugLine="Dim argb() As Int = GetARGB(clr)";
_argb = _getargb(_clr);
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="Dim factor As Float = 0.75";
_factor = (float) (0.75);
RDebugUtils.currentLine=262147;
 //BA.debugLineNum = 262147;BA.debugLine="Return xui.Color_RGB(argb(1) * factor, argb(2) *";
if (true) return mostCurrent._xui.Color_RGB((int) (_argb[(int) (1)]*_factor),(int) (_argb[(int) (2)]*_factor),(int) (_argb[(int) (3)]*_factor));
RDebugUtils.currentLine=262148;
 //BA.debugLineNum = 262148;BA.debugLine="End Sub";
return 0;
}
public static int[]  _getargb(int _color) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "getargb"))
	return (int[]) Debug.delegate(mostCurrent.activityBA, "getargb", new Object[] {_color});
int[] _res = null;
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub GetARGB(Color As Int) As Int()";
RDebugUtils.currentLine=327681;
 //BA.debugLineNum = 327681;BA.debugLine="Private res(4) As Int";
_res = new int[(int) (4)];
;
RDebugUtils.currentLine=327682;
 //BA.debugLineNum = 327682;BA.debugLine="res(0) = Bit.UnsignedShiftRight(Bit.And(Color, 0x";
_res[(int) (0)] = anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_color,(int) (0xff000000)),(int) (24));
RDebugUtils.currentLine=327683;
 //BA.debugLineNum = 327683;BA.debugLine="res(1) = Bit.UnsignedShiftRight(Bit.And(Color, 0x";
_res[(int) (1)] = anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_color,(int) (0xff0000)),(int) (16));
RDebugUtils.currentLine=327684;
 //BA.debugLineNum = 327684;BA.debugLine="res(2) = Bit.UnsignedShiftRight(Bit.And(Color, 0x";
_res[(int) (2)] = anywheresoftware.b4a.keywords.Common.Bit.UnsignedShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And(_color,(int) (0xff00)),(int) (8));
RDebugUtils.currentLine=327685;
 //BA.debugLineNum = 327685;BA.debugLine="res(3) = Bit.And(Color, 0xff)";
_res[(int) (3)] = anywheresoftware.b4a.keywords.Common.Bit.And(_color,(int) (0xff));
RDebugUtils.currentLine=327686;
 //BA.debugLineNum = 327686;BA.debugLine="Return res";
if (true) return _res;
RDebugUtils.currentLine=327687;
 //BA.debugLineNum = 327687;BA.debugLine="End Sub";
return null;
}
public static String  _listview1_itemclick(int _position,Object _value) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "listview1_itemclick"))
	return (String) Debug.delegate(mostCurrent.activityBA, "listview1_itemclick", new Object[] {_position,_value});
RDebugUtils.currentLine=917504;
 //BA.debugLineNum = 917504;BA.debugLine="Sub ListView1_ItemClick (Position As Int, Value As";
RDebugUtils.currentLine=917505;
 //BA.debugLineNum = 917505;BA.debugLine="ToastMessageShow($\"Value--> ${Value}\"$, False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence(("Value--> "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",_value)+"")),anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=917506;
 //BA.debugLineNum = 917506;BA.debugLine="End Sub";
return "";
}
}